"""
A simple script to check the status of a few fax transmissions
using the InterFAX FaxQuery SOAP API call.
"""
import osa

client = osa.Client("http://ws.interfax.net/dfs.asmx?WSDL")

print('Testing FaxQuery...')

result = client.service.FaxQuery(Username='', Password='',
                         Verb = 'LT',
                         VerbData = 999999999,
                         MaxItems = 10, ResultCode=0)

if result.ResultCode == 0:
    all_items = result.FaxQueryResult.FaxItemEx
    for  i in vars(result):
            item = getattr(result,i,"")
            print( "{}:\t{}".format(i, str(item)))

    print('   FaxQuery returned with code %d and %d items' % (result.ResultCode, len(result.FaxQueryResult.FaxItemEx)))
    # Print details for each item.
    for current_item in all_items:
          for i in vars(current_item):
            item = getattr(current_item,i,"")
            print( "{}:\t{}".format(i, str(item)))

else:
    print('   FaxQuery returned with code {}'.format(result['ResultCode']))